
/*
    Copyright (C) 1996 Alistair Conkie
 
    You may distribute under the terms of the GNU General Public
    Licence as specified in the README file.
*/
/* working note...
   This will now work in 2 stages, with the first being writing the
   utterance in one long string (plus associated housekeeping)
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "t2s.h"
#include "prototypes.h"

static void sil_fill(int j, char *shape, float factor, int durn, SENT *sent);

void conv1(CONFIG *config, LING_LIST *ling_list, SENT *sent)
{
	int count = ling_list->sz;
	int j = 0;  	/* phoneme counter  */
	int i,k;
	char **plist;
	int tot_char = 0;

	if((2*count)>sent->sil_max) {
	        sent_realloc(sent->list_max,2*sent->sil_max,sent);
	}
	for(i=0;i<count;i++) {
	        tot_char += strlen(ling_list->text[i]->word) + 2;
	}
	if((2*tot_char)>sent->list_max) {
	        sent_realloc(2*sent->list_max,sent->sil_max,sent);
	}


	sil_fill(j++,"H[",1.0,50,sent);
	strcpy(sent->list,"##");
	for(i=0;i<count;i++) {
		if(ling_list->text[i]->type == PUNCT) {
			if(ling_list->text[i]->word[0] == '\0') {
                        	sil_fill(j++,"L-H]",0.2,0,sent);	
				strcat(sent->list," #");
			} else if(ling_list->text[i]->word[0] == '-') {
			        sil_fill(j++,"L-H]",0.7,50,sent);
				strcat(sent->list," ##");
			} else if(ling_list->text[i]->word[0] == ':') {
			        sil_fill(j++,"L-H]",0.7,750,sent);
				strcat(sent->list," ##");
			} else if(ling_list->text[i]->word[0] == ';') {
			        sil_fill(j++,"L-L]",0.7,750,sent);
				strcat(sent->list," ##");
			} else if(ling_list->text[i]->word[0] == '.') {
			        sil_fill(j++,"L-L]",1.0,1200,sent);
				strcat(sent->list," ##");
			} else if(ling_list->text[i]->word[0] == '!') {
			        sil_fill(j++,"L-L]",1.0,1200,sent);
				strcat(sent->list," ##");
			} else if(ling_list->text[i]->word[0] == '?') {
			        sil_fill(j++,"L-H]",1.0,1200,sent);
				strcat(sent->list," ##");
			} else {
			        sil_fill(j++,"L-H]",0.7,200,sent);
				strcat(sent->list," ##");
			} /* more of same to follow  */
		} else {
			/* CW and FW  */
			plist = split(ling_list->text[i]->transcription);
			/* the glue ('|')  */
			if(sent->list[strlen(sent->list)-1]!='#') {
			        strcat(sent->list," |");
			}
			k = 0;
			while(plist[k] != NULL) {
				if(islower(plist[k][0])) {  /* phoneme  */
				        strcat(sent->list," ");
					strcat(sent->list,plist[k]);
				} else if(plist[k][0] == '.' || plist[k][0] == '-' || plist[k][0] == '+' || plist[k][0] == '|') {
				        strcat(sent->list," ");
					strcat(sent->list,plist[k]);
				} else if(plist[k][0] == '*') {
					if(ling_list->text[i]->type == CW) {
					        strcat(sent->list," *");
					}
				} else if(plist[k][0] == '~') {
					if(ling_list->text[i]->type == CW) {
					        strcat(sent->list," ~");
					} 
				}
				k++;
			}
			tidy_split(plist);
		}
	}
	if(sent->list[strlen(sent->list)-1] != '#') {
	        sil_fill(j++,"",0.0,1200,sent);
	        strcat(sent->list," ##");
	}

	sent->sil_sz = j;
}

static void sil_fill(int j, char *shape, float factor, int durn, SENT *sent)
{
        sent->sil[j].shape = shape;        
	sent->sil[j].factor = factor;        
	sent->sil[j].durn = durn;
}
