/*
    Copyright (C) 1996 Alistair Conkie
 
    You may distribute under the terms of the GNU General Public
    Licence as specified in the README file.
*/

#include <stdio.h>
#include <stdlib.h>
#include "t2s.h"
#include "prototypes.h"

static void add_to_buff(char append, BUFFER *buffer);
static void zero_things(BUFFER *buffer, LING_LIST *ling_list);

void go(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps, ACOUSTIC *as) 
{
	int i, len;
	int last_complete = 1;
	char c, c1;
	char line[1024];

        while(fgets(line,1024,config->ifd) != NULL) {
                
                if(!strcmp(line,"\n") && last_complete)  {
	                process_sentence(config, buffer, ling_list, sent, spl, ps, as);
			zero_things(buffer,ling_list);
		} else { 
        		for(i=0,len=strlen(line);i<len;i++) {
				c = line[i];
				switch(c) {
		
				case '.' : case '?' : case '!' :
	        			add_to_buff(' ',buffer);
	        			add_to_buff(c,buffer);
	        			add_to_buff(' ',buffer);
					c1 = line[i+1];
					if(c1==' ' || c1=='\t' || c1=='\n') {
	                			process_sentence(config, buffer, ling_list, sent, spl, ps, as);
						zero_things(buffer, ling_list);
					}
					break;
	
				case '(' : case ')' : case '[' :
				case ']' : case '{' : case '}' :
				case ':' : case ';' : case ',' :
	        			add_to_buff(' ',buffer);
	        			add_to_buff(c,buffer);
	        			add_to_buff(' ',buffer);
					break;
	
				case ' ' : case '\n' : case '\t' :
					add_to_buff(' ',buffer);
					break;
	
				default :
					add_to_buff(c,buffer);
					break;
				}
			}
			last_complete = (line[len-1] == '\n');
		}
	}
	process_sentence(config, buffer, ling_list, sent, spl, ps, as);
	zero_things(buffer,ling_list);
}

void go3(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps) 
{
	int i, len;
	int last_complete = 1;
	char c, c1;
	char line[1024];

        while(fgets(line,1024,config->ifd) != NULL) {
                
                if(!strcmp(line,"\n") && last_complete)  {
	                produce_spn_file(config, buffer, ling_list, sent, spl, ps);
			zero_things(buffer,ling_list);
		} else { 
        		for(i=0,len=strlen(line);i<len;i++) {
				c = line[i];
				switch(c) {
		
				case '.' : case '?' : case '!' :
	        			add_to_buff(' ',buffer);
	        			add_to_buff(c,buffer);
	        			add_to_buff(' ',buffer);
					c1 = line[i+1];
					if(c1==' ' || c1=='\t' || c1=='\n') {
	                			produce_spn_file(config, buffer, ling_list, sent, spl, ps);
						zero_things(buffer, ling_list);
					}
					break;
	
				case '(' : case ')' : case '[' :
				case ']' : case '{' : case '}' :
				case ':' : case ';' : case ',' :
	        			add_to_buff(' ',buffer);
	        			add_to_buff(c,buffer);
	        			add_to_buff(' ',buffer);
					break;
	
				case ' ' : case '\n' : case '\t' :
					add_to_buff(' ',buffer);
					break;
	
				default :
					add_to_buff(c,buffer);
					break;
				}
			}
			last_complete = (line[len-1] == '\n');
		}
	}
	produce_spn_file(config, buffer, ling_list, sent, spl, ps);
	zero_things(buffer,ling_list);
}

void go2(CONFIG *config, SPN *ps, ACOUSTIC *as) 
{
	process_spn_file(config, ps, as);
}
	
static void add_to_buff(char append, BUFFER *buffer)  
{
	if(((buffer->sz+1) - buffer->max) >= 0) {
		buffer_realloc(2*(buffer->max),buffer);
	}
	buffer->ptr[(buffer->sz)++] = append;
	buffer->ptr[buffer->sz] = '\0';
}

static void zero_things(BUFFER *buffer, LING_LIST *ling_list)
{
	int i;

	/* first the buffer  */
 	buffer->ptr[0] = '\0';
	buffer->sz = 0;

	/* then ling_list  */
	for(i=0;i<ling_list->sz;i++) {
		free(ling_list->text[i]->word);
		free(ling_list->text[i]->transcription);
	}
}

