/* program prototypes  */

/* audio.c  */
void output_open(CONFIG *config);
void output_close(CONFIG *config);
void audio_play(short *start,int sz,int number,CONFIG *config);

/* assim.c  */
void assim(SPROSOD_LIST *spl);

/* coeffs.c  */
void rfctolpc(int NCOEFFS, float *buf);

/* conv1.c  */
void conv1(CONFIG *config, LING_LIST *ling_list, SENT *sent);

/* conv2.c  */
void conv2(CONFIG *config, SENT *sent, SPROSOD_LIST *spl);
int vowel(char *ph) ;

/* durations.c  */
void durations(CONFIG *config, SPN *ps, ACOUSTIC *as);

/* durpros.c  */
void durpros(CONFIG *config, SPROSOD_LIST *spl);

/* edin2sampa.c */
char *edin2sampa(char *phon);

/* excitation.c  */
float iexc(short voiced, ACOUSTIC *as, short *wkspace);

/* go.c  */
void go(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps, ACOUSTIC *as);
void go3(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps);
void go2(CONFIG *config, SPN *ps, ACOUSTIC *as);

/* grammar.c  */
void grammar(LING_LIST *ling_list);

/* interface.c  */
char *nrl_rules(char *in);

/* load_diphs.c  */
void load_speech(CONFIG *config);
int lookup(char *diph);
void phonstoframes(SPN *ps, ACOUSTIC *as);
void unload_diphs(CONFIG *config);

/* make_wave.c  */
void make_wave(CONFIG *config, ACOUSTIC *as);

/* nrl_edin.c  */
void nrl_edin_conv(char *str, char *str2);

/* phon_rules.c  */
void phon_rules_init();
void phon_rules_free();
void phon_rules(SENT *sent);
void load_context_rules(char * filename);

/* pitch.c  */
void calc_pitch(CONFIG *config, SPN *ps, ACOUSTIC *as);

/* prosody.c  */
void prosody(SPROSOD_LIST *spl, SPN *ps); 

/* space.c  */
void init(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps, ACOUSTIC *as);
void terminate(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps, ACOUSTIC *as);
void buffer_malloc(int num,BUFFER *buffer);
void buffer_realloc(int num, BUFFER *buffer);
void buffer_free(BUFFER *buffer);
void ling_list_malloc(int num, LING_LIST *ling_list);
void ling_list_realloc(int num, LING_LIST *ling_list);
void ling_list_free(LING_LIST *ling_list);
void sent_malloc(int num1, int num2, SENT *sent);
void sent_realloc(int num1, int num2, SENT *sent);
void sent_free(SENT *sent);
void spl_malloc(int num, SPROSOD_LIST *spl);
void spl_realloc(int num, SPROSOD_LIST *spl);
void spl_free(SPROSOD_LIST *spl);
void ps_malloc(int nphons, int ntargs, SPN *ps);
void ps_realloc(int nphons, int ntargs, SPN *ps);
void ps_free(SPN *ps);
void as_malloc(int nframes, int npp, ACOUSTIC *as);
void as_realloc(int nframes, int npp, ACOUSTIC *as);
void as_free(ACOUSTIC *as);

/* spnio.c  */
void put_mbrola_data(CONFIG *config, SPN *ps);
void put_spn_data(CONFIG *config, SPN *ps);
void get_spn_data(CONFIG *config, SPN *ps);

/* syllab.c  */
char *syllabify(char *string, CONFIG *config);
char *stress(char *input);

/* t2s.c  */
void process_sentence(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps, ACOUSTIC *as);
void produce_spn_file(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list, SENT *sent, SPROSOD_LIST *spl, SPN *ps);
void process_spn_file(CONFIG *config, SPN *ps, ACOUSTIC *as);

/* tags.c  */
void tags(CONFIG *config, BUFFER *buffer, LING_LIST *ling_list);

/* transcribe.c  */
void transcribe(CONFIG *config, LING_LIST *ling_list);

/* rule_engine.c  */

/* ulaw.c  */
unsigned char linear2ulaw(int sample);
int ulaw2linear(unsigned char ulawbyte);

/* utils.c  */
char **split(char *in);
void tidy_split(char **root);
KEY *binary(char *word, KEY tab[], int n);
PKEY *pbinary(char *word, PKEY tab[], int n);
